#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int
main(int argc, char* argv[])
{
	FILE* fp;
	unsigned char buf[4096];
	int ofs, len, i;

	/* USAGE: bin2c binary-fname > text-fname */
	if(argc != 1 + 1) abort();

	/* file open */
	fp = fopen(argv[1], "rb");
	if(fp == NULL) abort();

	ofs = 0;
	for(;;) {
		/* read block */
		len = fread(buf, 1, sizeof buf, fp);
		if(len == 0) break;
		/* print offset */
		printf("/*%05x*/", ofs);
		/* write block */
		for(i = 0; i < len; i++) {
			if(i % 32 == 0) printf("\n");
			printf("0x%02x,", buf[i]);
			ofs++;
		}
		printf("\n");
	}
	/* print total */
	printf("/*%05x*/\n", ofs);

	/* file close */
	fclose(fp);

	return 0;
}
